#!/usr/bin/perl -w
#
# vmware /etc/vmware/locations file cleaner
# 20100910 - Paul Mansfield

use strict;

my $DIRTY='/etc/vmware/locations';
my $CLEANED='/etc/vmware/locations.cleaned';

open(FHIN, "<$DIRTY") or die "failed to open $DIRTY";
open(FHOUT, ">$CLEANED") or die "failed to open $CLEANED";

$| = 1;	# unbuffered stdout

print STDERR "reading in $DIRTY\n";

# parse the locations file
my @locs;
my $locLine = 0;
while(<FHIN>)
{
	chomp;
	my @newLoc = split(/ /);	

	if ($newLoc[0] eq 'remove_file')
	{
		#print STDERR "scanning to remove_file $newLoc[1]\n";
		for (my $x = 0; $x < $locLine; ++$x)
		{
			if (($locs[$x][0] eq 'file') && ($locs[$x][1] eq $newLoc[1]))
			{
				#print STDERR "found file, scrubbing\n";
				$locs[$x][0] = "#file";
				last;
			}
		}
	}
	elsif ($newLoc[0] eq 'remove_answer')
	{
		#print STDERR "scanning to remove_answer $newLoc[1]\n";
		for (my $x = 0; $x < $locLine; ++$x)
		{
			if (($locs[$x][0] eq 'answer') && ($locs[$x][1] eq $newLoc[1]))
			{
				#print STDERR "found answer, scrubbing\n";
				$locs[$x][0] = "#answer";
				last;
			}
		}
	}
	else
	{
		#print STDERR "storing\n";
		push @locs, [ @newLoc ];
		$locLine++
	}
}
close(FHIN);

# print the cleaned up results
print STDERR "writing out $CLEANED\n";
for (my $x = 0; $x < $locLine; ++$x)
{
	if (substr($locs[$x][0], 0, 1) ne '#')
	{
		print FHOUT join(' ', @{ $locs[$x] } ) . "\n";
	}
}
close(FHOUT);


# end of cleanup-locations.pl
